--key=mimcID, value=armyID 
local mimcIDs = {}

--function to give units to an allied player
function mimc_giveSelectedUnitsToAlly(giveAll, mimcID)

	local focusArmy = GetFocusArmy()
	
	if mimcIDs[mimcID] ~= nil and IsAlly(focusArmy, mimcIDs[mimcID]) then
		if (giveAll) then

			UISelectionByCategory("ALLUNITS", false, false, false, false)
			
			--first give to preferred mate
			SimCallback( { Func="GiveResourcesToPlayer",
        	                   Args={ From=focusArmy,
                	                  To=mimcIDs[mimcID],
                        	          Mass= 100.0 / 100.0,
                                	  Energy= 100.0 / 100.0,
                                	}
                             	} )
			SimCallback({Func="GiveUnitsToPlayer", Args={ From=focusArmy, To=mimcIDs[mimcID]},} , true)
			
	 	 	for index, id in getAllyIDs(mimcID) do
				
				--Give Ressources to current mate.
				SimCallback( { Func="GiveResourcesToPlayer",
        	                   Args={ From=focusArmy,
                	                  To=id,
                        	          Mass= 100.0 / 100.0,
                                	  Energy= 100.0 / 100.0,
                                	}
                             	} )
                --Give Units to current mate.
				SimCallback({Func="GiveUnitsToPlayer", Args={ From=focusArmy, To=id},} , true)
			end

		else
			SimCallback({Func="GiveUnitsToPlayer", Args={ From=GetFocusArmy(), To=mimcIDs[mimcID]},} , true)
		end
	end
end

function mimc_giveRessToAlly(massValue, energieValue, mimcID)

	local focusArmy = GetFocusArmy()
	
	if mimcIDs[mimcID] ~= nil and IsAlly(focusArmy, mimcIDs[mimcID]) then
		SimCallback( { Func="GiveResourcesToPlayer",
                           Args={ From=GetFocusArmy(),
                                  To=mimcIDs[mimcID],
                                  Mass= massValue / 100.0,
                                  Energy= energieValue / 100.0,
                                }
                             }
                           )
	end
end

--function to get all allied ids
function getAllyIDs(mimcID)

	local focusArmy = GetFocusArmy()
    local armyIndices = {}
    local i = 1
    local j = 0
    for index, playerInfo in GetArmiesTable().armiesTable do

        if IsAlly(focusArmy, index) and index ~= focusArmy and index ~= mimcIDs[mimcID] then
		armyIndices[j] = index
		j = j + 1
        end

        i = i + 1
    end

    return armyIndices
end

--returns a new name for each teamate including his MIMC-ID
function mimc_getNewNickname(armyIndex, nickname)    
	
    local newNickname = nickname
    local mimcID = 1
    local focusArmy = GetFocusArmy()
    local armiesInfo = GetArmiesTable().armiesTable

    if not SessionIsReplay() and not armiesInfo[focusArmy].outOfGame then
    
        for index, playerInfo in armiesInfo do
    	    --check if id is from a teammate
            if IsAlly(focusArmy, index) and index ~= focusArmy and mimcID < 4 and not playerInfo.outOfGame then
        	if  index == armyIndex then
        	    --save mimcID and armyIndex
                    mimcIDs[mimcID] = armyIndex
        	    --we have our mate, so we can return newNickname
        	    newNickname = newNickname  .. '(' .. mimcID .. ')'
		    break
		else
		    mimcID = mimcID + 1
		end
            end

        end

    end

    return newNickname
end